﻿#include <fstream>
#include <string>
#include <iostream>
#include <utility>
#include "AneuMeshLoader.h"


void AneuMeshLoader::LoadMesh(std::string path)
{
	using namespace std;
	ifstream in(path);
	if (in.is_open())
	{

		//Nodes
		int count;
		in >> count;
		this->Nodes.reserve(count);
		int dim;
		in >> dim;
		for (int i = 1; i <= count; i++)
		{
			Node curNode;
			curNode.cords.reserve(dim);
			curNode.nodeId = i;
			curNode.isEdge = true;
			double coord;
			for (int j = 0; j < dim; j++)
			{
				in >> coord;
				curNode.cords.push_back(coord);
			}
			this->Nodes.push_back(curNode);
		}




		//FiniteElements
		in >> count;
		this->FiniteElements.reserve(count);
		in >> dim;
		for (int i = 1; i <= count; i++)
		{
			FiniteElement curFiniteElement;
			curFiniteElement.nodesId.reserve(dim);
			curFiniteElement.elementId = i;
			in >> curFiniteElement.entityId;
			unsigned int temp;
			for (int j = 0; j < dim; j++)
			{
				in >> temp;
				curFiniteElement.nodesId.push_back(temp);
			}
			this->FiniteElements.push_back(std::move(curFiniteElement));
		}



		//BoundaryFiniteElements
		in >> count;
		this->BoundaryFiniteElements.reserve(count);
		in >> dim;
		for (int i = 1; i <= count; i++)
		{
			BoundaryFiniteElement curBoundaryFiniteElement;
			curBoundaryFiniteElement.nodesId.reserve(dim);
			in >> curBoundaryFiniteElement.boundaryID;
			curBoundaryFiniteElement.elementId = i;
			//curBoundaryFiniteElement.surfaceID = i;
			unsigned int temp;
			for (int j = 0; j < dim; j++)
			{
				in >> temp;
				curBoundaryFiniteElement.nodesId.push_back(temp);
			}
			this->BoundaryFiniteElements.push_back(std::move(curBoundaryFiniteElement));
		}


		in.close();
	}
	else
	{
		throw std::runtime_error("Unable to load geomentry file");
	}
}



