#pragma once
#include <iostream>
#include <string>
#include "Structures.h"
#include <vector>
class MeshLoader
{
protected:
	std::vector<Node> Nodes;
	std::vector<FiniteElement> FiniteElements;
	std::vector<BoundaryFiniteElement> BoundaryFiniteElements;
public:
	MeshLoader();
	virtual void LoadMesh(std::string path) = 0;
	~MeshLoader();
	std::vector<Node>& getNodes();
	std::vector<FiniteElement>& getFiniteElements();
	std::vector<BoundaryFiniteElement>& getBoundaryFiniteElements();
	std::vector<FiniteElement&> findElem(int id_1, int id_2);
	std::vector<FiniteElement&> findElem(int id_1, int id_2, int id_3);
	std::vector<unsigned int>& getNodesByBoundaryFiniteElementID(int id);
};
std::ostream& operator<<(std::ostream& stream, MeshLoader& mesh);