#include <vector>
#include <iostream>
struct FiniteElement
{
	unsigned int elementId;
	unsigned int entityId;
	std::vector<unsigned int> nodesId;
};

struct Node
{
	unsigned int nodeId;
	bool isEdge;
	std::vector<double> cords;
};

struct BoundaryFiniteElement : public FiniteElement
{
	unsigned int boundaryID;
	//unsigned int surfaceID;
};


inline std::ostream& operator<<(std::ostream& stream, const Node& node)
{
	stream << "(" << node.nodeId << ") ";
	for (auto& i : node.cords)
	{
		stream << i << " ";
	}
	if (node.isEdge)
	{
		stream << "Is edge";
	}
	else
		stream << "Isnt edge";
	stream << std::endl;
	return stream;
}

inline std::ostream& operator<<(std::ostream& stream, const FiniteElement& finiteElement)
{
	stream << "(" << finiteElement.elementId << ") ";
	stream << "<" << finiteElement.entityId << "> ";
	for (auto& j : finiteElement.nodesId)
	{
		stream << j << " ";
	}
	stream << std::endl;
	return stream;
}

inline std::ostream& operator<<(std::ostream& stream, const BoundaryFiniteElement& boundaryFiniteElement)
{
	stream << "(" << boundaryFiniteElement.elementId << ") ";
	stream << "<" << boundaryFiniteElement.boundaryID << "> ";
	for (auto& j : boundaryFiniteElement.nodesId)
	{
		stream << j << " ";
	}
	stream << std::endl;
	return stream;
}